lens-3.9.0.2: Lenses, Folds and Traversals

Portability | non-portable
Stability | experimental
Maintainer | Edward Kmett <ekmett@gmail.com>
Safe Haskell | Trustworthy

Control.Lens.Internal.Iso

Description

Synopsis

- data Exchange a b s t = Exchange (s -> a) (b -> t)
- class Reversing t where
  - reversing :: t -> t

# Documentation

data Exchange a b s t

This is used internally by the `Iso` code to provide efficient access to the two functions that make up an isomorphism.

Constructors

Exchange (s -> a) (b -> t) |

Instances

Profunctor (Exchange a b) |
Functor (Exchange a b s) |

class Reversing t where

This class provides a generalized notion of list reversal extended to other containers.

Methods

reversing :: t -> t

Instances

Reversing ByteString |
Reversing ByteString |
Reversing Text |
Reversing Text |
Reversing [a] |
Reversing (Seq a) |
Reversing (Vector a) |
Unbox a => Reversing (Vector a) |
Storable a => Reversing (Vector a) |
Prim a => Reversing (Vector a) |
Reversing (Deque a) |